"use strict";
var LitJsSdk_litStorage = (() => {
  var __defProp = Object.defineProperty;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __export = (target, all) => {
    for (var name in all)
      __defProp(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key of __getOwnPropNames(from))
        if (!__hasOwnProp.call(to, key) && key !== except)
          __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

  // packages/lit-storage/src/index.ts
  var src_exports = {};
  __export(src_exports, {
    LitNodejsStorage: () => LitNodejsStorage,
    LitStorage: () => LitStorage
  });

  // packages/lit-storage/src/lib/lit-nodejs-storage.ts
  var LitNodejsStorage = class {
    constructor() {
      this.storage = {};
    }
    get length() {
      return Object.keys(this.storage).length;
    }
    clear() {
      this.storage = {};
    }
    getItem(key) {
      const item = this.storage[key];
      return item || null;
    }
    key(index) {
      const keys = Object.keys(this.storage);
      return keys[index] || null;
    }
    removeItem(key) {
      delete this.storage[key];
    }
    setItem(key, value) {
      this.storage[key] = value;
    }
  };

  // packages/constants/src/lib/constants/constants.ts
  var LIT_CHAINS = {
    ethereum: {
      contractAddress: "0xA54F7579fFb3F98bd8649fF02813F575f9b3d353",
      chainId: 1,
      name: "Ethereum",
      symbol: "ETH",
      decimals: 18,
      type: "ERC1155",
      rpcUrls: [
        "https://eth-mainnet.alchemyapi.io/v2/EuGnkVlzVoEkzdg0lpCarhm8YHOxWVxE"
      ],
      blockExplorerUrls: ["https://etherscan.io"],
      vmType: "EVM"
    },
    polygon: {
      contractAddress: "0x7C7757a9675f06F3BE4618bB68732c4aB25D2e88",
      chainId: 137,
      name: "Polygon",
      symbol: "MATIC",
      decimals: 18,
      rpcUrls: ["https://polygon-rpc.com"],
      blockExplorerUrls: ["https://explorer.matic.network"],
      type: "ERC1155",
      vmType: "EVM"
    },
    fantom: {
      contractAddress: "0x5bD3Fe8Ab542f0AaBF7552FAAf376Fd8Aa9b3869",
      chainId: 250,
      name: "Fantom",
      symbol: "FTM",
      decimals: 18,
      rpcUrls: ["https://rpcapi.fantom.network"],
      blockExplorerUrls: ["https://ftmscan.com"],
      type: "ERC1155",
      vmType: "EVM"
    },
    xdai: {
      contractAddress: "0xDFc2Fd83dFfD0Dafb216F412aB3B18f2777406aF",
      chainId: 100,
      name: "xDai",
      symbol: "xDai",
      decimals: 18,
      rpcUrls: ["https://rpc.gnosischain.com"],
      blockExplorerUrls: [" https://blockscout.com/xdai/mainnet"],
      type: "ERC1155",
      vmType: "EVM"
    },
    bsc: {
      contractAddress: "0xc716950e5DEae248160109F562e1C9bF8E0CA25B",
      chainId: 56,
      name: "Binance Smart Chain",
      symbol: "BNB",
      decimals: 18,
      rpcUrls: ["https://bsc-dataseed.binance.org/"],
      blockExplorerUrls: [" https://bscscan.com/"],
      type: "ERC1155",
      vmType: "EVM"
    },
    arbitrum: {
      contractAddress: "0xc716950e5DEae248160109F562e1C9bF8E0CA25B",
      chainId: 42161,
      name: "Arbitrum",
      symbol: "AETH",
      decimals: 18,
      type: "ERC1155",
      rpcUrls: ["https://arb1.arbitrum.io/rpc"],
      blockExplorerUrls: ["https://arbiscan.io/"],
      vmType: "EVM"
    },
    avalanche: {
      contractAddress: "0xBB118507E802D17ECDD4343797066dDc13Cde7C6",
      chainId: 43114,
      name: "Avalanche",
      symbol: "AVAX",
      decimals: 18,
      type: "ERC1155",
      rpcUrls: ["https://api.avax.network/ext/bc/C/rpc"],
      blockExplorerUrls: ["https://snowtrace.io/"],
      vmType: "EVM"
    },
    fuji: {
      contractAddress: "0xc716950e5DEae248160109F562e1C9bF8E0CA25B",
      chainId: 43113,
      name: "Avalanche FUJI Testnet",
      symbol: "AVAX",
      decimals: 18,
      type: "ERC1155",
      rpcUrls: ["https://api.avax-test.network/ext/bc/C/rpc"],
      blockExplorerUrls: ["https://testnet.snowtrace.io/"],
      vmType: "EVM"
    },
    harmony: {
      contractAddress: "0xBB118507E802D17ECDD4343797066dDc13Cde7C6",
      chainId: 16666e5,
      name: "Harmony",
      symbol: "ONE",
      decimals: 18,
      type: "ERC1155",
      rpcUrls: ["https://api.harmony.one"],
      blockExplorerUrls: ["https://explorer.harmony.one/"],
      vmType: "EVM"
    },
    mumbai: {
      contractAddress: "0xc716950e5DEae248160109F562e1C9bF8E0CA25B",
      chainId: 80001,
      name: "Mumbai",
      symbol: "MATIC",
      decimals: 18,
      rpcUrls: [
        "https://rpc-mumbai.maticvigil.com/v1/96bf5fa6e03d272fbd09de48d03927b95633726c"
      ],
      blockExplorerUrls: ["https://mumbai.polygonscan.com"],
      type: "ERC1155",
      vmType: "EVM"
    },
    goerli: {
      contractAddress: "0xc716950e5DEae248160109F562e1C9bF8E0CA25B",
      chainId: 5,
      name: "Goerli",
      symbol: "ETH",
      decimals: 18,
      rpcUrls: ["https://goerli.infura.io/v3/96dffb3d8c084dec952c61bd6230af34"],
      blockExplorerUrls: ["https://goerli.etherscan.io"],
      type: "ERC1155",
      vmType: "EVM"
    },
    cronos: {
      contractAddress: "0xc716950e5DEae248160109F562e1C9bF8E0CA25B",
      chainId: 25,
      name: "Cronos",
      symbol: "CRO",
      decimals: 18,
      rpcUrls: ["https://evm-cronos.org"],
      blockExplorerUrls: ["https://cronos.org/explorer/"],
      type: "ERC1155",
      vmType: "EVM"
    },
    optimism: {
      contractAddress: "0xbF68B4c9aCbed79278465007f20a08Fa045281E0",
      chainId: 10,
      name: "Optimism",
      symbol: "ETH",
      decimals: 18,
      rpcUrls: ["https://mainnet.optimism.io"],
      blockExplorerUrls: ["https://optimistic.etherscan.io"],
      type: "ERC1155",
      vmType: "EVM"
    },
    celo: {
      contractAddress: "0xBB118507E802D17ECDD4343797066dDc13Cde7C6",
      chainId: 42220,
      name: "Celo",
      symbol: "CELO",
      decimals: 18,
      rpcUrls: ["https://forno.celo.org"],
      blockExplorerUrls: ["https://explorer.celo.org"],
      type: "ERC1155",
      vmType: "EVM"
    },
    aurora: {
      contractAddress: null,
      chainId: 1313161554,
      name: "Aurora",
      symbol: "ETH",
      decimals: 18,
      rpcUrls: ["https://mainnet.aurora.dev"],
      blockExplorerUrls: ["https://aurorascan.dev"],
      type: null,
      vmType: "EVM"
    },
    eluvio: {
      contractAddress: null,
      chainId: 955305,
      name: "Eluvio",
      symbol: "ELV",
      decimals: 18,
      rpcUrls: ["https://host-76-74-28-226.contentfabric.io/eth"],
      blockExplorerUrls: ["https://explorer.eluv.io"],
      type: null,
      vmType: "EVM"
    },
    alfajores: {
      contractAddress: null,
      chainId: 44787,
      name: "Alfajores",
      symbol: "CELO",
      decimals: 18,
      rpcUrls: ["https://alfajores-forno.celo-testnet.org"],
      blockExplorerUrls: ["https://alfajores-blockscout.celo-testnet.org"],
      type: null,
      vmType: "EVM"
    },
    xdc: {
      contractAddress: null,
      chainId: 50,
      name: "XDC Blockchain",
      symbol: "XDC",
      decimals: 18,
      rpcUrls: ["https://rpc.xinfin.network"],
      blockExplorerUrls: ["https://explorer.xinfin.network"],
      type: null,
      vmType: "EVM"
    },
    evmos: {
      contractAddress: null,
      chainId: 9001,
      name: "EVMOS",
      symbol: "EVMOS",
      decimals: 18,
      rpcUrls: ["https://eth.bd.evmos.org:8545"],
      blockExplorerUrls: ["https://evm.evmos.org"],
      type: null,
      vmType: "EVM"
    },
    evmosTestnet: {
      contractAddress: null,
      chainId: 9e3,
      name: "EVMOS Testnet",
      symbol: "EVMOS",
      decimals: 18,
      rpcUrls: ["https://eth.bd.evmos.dev:8545"],
      blockExplorerUrls: ["https://evm.evmos.dev"],
      type: null,
      vmType: "EVM"
    },
    bscTestnet: {
      contractAddress: null,
      chainId: 97,
      name: "BSC Testnet",
      symbol: "BNB",
      decimals: 18,
      rpcUrls: ["https://data-seed-prebsc-1-s1.binance.org:8545"],
      blockExplorerUrls: ["https://testnet.bscscan.com/"],
      type: null,
      vmType: "EVM"
    },
    baseGoerli: {
      contractAddress: null,
      chainId: 84531,
      name: "Base Goerli",
      symbol: "ETH",
      decimals: 18,
      rpcUrls: ["https://goerli.base.org"],
      blockExplorerUrls: ["https://goerli.basescan.org"],
      type: null,
      vmType: "EVM"
    },
    moonbeam: {
      contractAddress: null,
      chainId: 1284,
      name: "Moonbeam",
      symbol: "GLMR",
      decimals: 18,
      rpcUrls: ["https://rpc.api.moonbeam.network"],
      blockExplorerUrls: ["https://moonscan.io"],
      type: null,
      vmType: "EVM"
    },
    moonriver: {
      contractAddress: null,
      chainId: 1285,
      name: "Moonriver",
      symbol: "MOVR",
      decimals: 18,
      rpcUrls: ["https://rpc.api.moonriver.moonbeam.network"],
      blockExplorerUrls: ["https://moonriver.moonscan.io"],
      type: null,
      vmType: "EVM"
    },
    moonbaseAlpha: {
      contractAddress: null,
      chainId: 1287,
      name: "Moonbase Alpha",
      symbol: "DEV",
      decimals: 18,
      rpcUrls: ["https://rpc.api.moonbase.moonbeam.network"],
      blockExplorerUrls: ["https://moonbase.moonscan.io/"],
      type: null,
      vmType: "EVM"
    },
    filecoin: {
      contractAddress: null,
      chainId: 314,
      name: "Filecoin",
      symbol: "FIL",
      decimals: 18,
      rpcUrls: ["https://api.node.glif.io/rpc/v1"],
      blockExplorerUrls: ["https://filfox.info/"],
      type: null,
      vmType: "EVM"
    },
    hyperspace: {
      contractAddress: null,
      chainId: 3141,
      name: "Filecoin Hyperspace testnet",
      symbol: "tFIL",
      decimals: 18,
      rpcUrls: ["https://api.hyperspace.node.glif.io/rpc/v1"],
      blockExplorerUrls: ["https://hyperspace.filscan.io/"],
      type: null,
      vmType: "EVM"
    },
    sepolia: {
      contractAddress: null,
      chainId: 11155111,
      name: "Sepolia Testnet",
      symbol: "ETH",
      decimals: 18,
      rpcUrls: ["https://eth-sepolia.g.alchemy.com/v2/demo"],
      blockExplorerUrls: ["https://sepolia.etherscan.io/"],
      type: null,
      vmType: "EVM"
    },
    scrollAlphaTestnet: {
      contractAddress: null,
      chainId: 534353,
      name: "Scroll Alpha Testnet",
      symbol: "ETH",
      decimals: 18,
      rpcUrls: ["https://alpha-rpc.scroll.io/l2"],
      blockExplorerUrls: ["https://blockscout.scroll.io/"],
      type: null,
      vmType: "EVM"
    },
    zksync: {
      contractAddress: null,
      chainId: 324,
      name: "zkSync Era Mainnet",
      symbol: "ETH",
      decimals: 18,
      rpcUrls: ["https://mainnet.era.zksync.io"],
      blockExplorerUrls: ["https://explorer.zksync.io/"],
      type: null,
      vmType: "EVM"
    },
    zksyncTestnet: {
      contractAddress: null,
      chainId: 280,
      name: "zkSync Era Testnet",
      symbol: "ETH",
      decimals: 18,
      rpcUrls: ["https://testnet.era.zksync.dev"],
      blockExplorerUrls: ["https://goerli.explorer.zksync.io/"],
      type: null,
      vmType: "EVM"
    },
    lineaGoerli: {
      contractAddress: null,
      chainId: 59140,
      name: "Linea Testnet",
      symbol: "ETH",
      decimals: 18,
      rpcUrls: ["https://rpc.goerli.linea.build"],
      blockExplorerUrls: ["https://explorer.goerli.linea.build"],
      type: null,
      vmType: "EVM"
    },
    chronicleTestnet: {
      contractAddress: null,
      chainId: 175177,
      name: "Chronicle - Lit Protocol Testnet",
      symbol: "LIT",
      decimals: 18,
      rpcUrls: ["https://chain-rpc.litprotocol.com/http"],
      blockExplorerUrls: ["https://chain.litprotocol.com/"],
      type: null,
      vmType: "EVM"
    },
    chiado: {
      contractAddress: null,
      chainId: 10200,
      name: "Chiado",
      symbol: "XDAI",
      decimals: 18,
      rpcUrls: ["https://rpc.chiadochain.net"],
      blockExplorerUrls: ["https://blockscout.chiadochain.net"],
      type: null,
      vmType: "EVM"
    },
    zkEvm: {
      contractAddress: null,
      chainId: 1101,
      name: "zkEvm",
      symbol: "ETH",
      decimals: 18,
      rpcUrls: ["https://zkevm-rpc.com"],
      blockExplorerUrls: ["https://zkevm.polygonscan.com/"],
      type: null,
      vmType: "EVM"
    },
    mantleTestnet: {
      contractAddress: null,
      chainId: 5001,
      name: "Mantle Testnet",
      symbol: "MNT",
      decimals: 18,
      rpcUrls: ["https://rpc.testnet.mantle.xyz"],
      blockExplorerUrls: ["https://explorer.testnet.mantle.xyz/"],
      type: null,
      vmType: "EVM"
    },
    mantle: {
      contractAddress: null,
      chainId: 5e3,
      name: "Mantle",
      symbol: "MNT",
      decimals: 18,
      rpcUrls: ["https://rpc.mantle.xyz"],
      blockExplorerUrls: ["http://explorer.mantle.xyz/"],
      type: null,
      vmType: "EVM"
    },
    klaytn: {
      contractAddress: null,
      chainId: 8217,
      name: "Klaytn",
      symbol: "KLAY",
      decimals: 18,
      rpcUrls: ["https://klaytn.blockpi.network/v1/rpc/public"],
      blockExplorerUrls: ["https://www.klaytnfinder.io/"],
      type: null,
      vmType: "EVM"
    },
    publicGoodsNetwork: {
      contractAddress: null,
      chainId: 424,
      name: "Public Goods Network",
      symbol: "ETH",
      decimals: 18,
      rpcUrls: ["https://rpc.publicgoods.network"],
      blockExplorerUrls: ["https://explorer.publicgoods.network/"],
      type: null,
      vmType: "EVM"
    },
    optimismGoerli: {
      contractAddress: null,
      chainId: 420,
      name: "Optimism Goerli",
      symbol: "ETH",
      decimals: 18,
      rpcUrls: ["https://optimism-goerli.publicnode.com"],
      blockExplorerUrls: ["https://goerli-optimism.etherscan.io/"],
      type: null,
      vmType: "EVM"
    },
    waevEclipseTestnet: {
      contractAddress: null,
      chainId: 91006,
      name: "Waev Eclipse Testnet",
      symbol: "ecWAEV",
      decimals: 18,
      rpcUrls: ["https://api.evm.waev.eclipsenetwork.xyz"],
      blockExplorerUrls: ["http://waev.explorer.modular.cloud/"],
      type: null,
      vmType: "EVM"
    },
    waevEclipseDevnet: {
      contractAddress: null,
      chainId: 91006,
      name: "Waev Eclipse Devnet",
      symbol: "ecWAEV",
      decimals: 18,
      rpcUrls: ["https://api.evm.waev.dev.eclipsenetwork.xyz"],
      blockExplorerUrls: ["http://waev.explorer.modular.cloud/"],
      type: null,
      vmType: "EVM"
    }
  };
  var LIT_SVM_CHAINS = {
    solana: {
      name: "Solana",
      symbol: "SOL",
      decimals: 9,
      rpcUrls: ["https://api.mainnet-beta.solana.com"],
      blockExplorerUrls: ["https://explorer.solana.com/"],
      vmType: "SVM"
    },
    solanaDevnet: {
      name: "Solana Devnet",
      symbol: "SOL",
      decimals: 9,
      rpcUrls: ["https://api.devnet.solana.com"],
      blockExplorerUrls: ["https://explorer.solana.com/"],
      vmType: "SVM"
    },
    solanaTestnet: {
      name: "Solana Testnet",
      symbol: "SOL",
      decimals: 9,
      rpcUrls: ["https://api.testnet.solana.com"],
      blockExplorerUrls: ["https://explorer.solana.com/"],
      vmType: "SVM"
    }
  };
  var LIT_COSMOS_CHAINS = {
    cosmos: {
      name: "Cosmos",
      symbol: "ATOM",
      decimals: 6,
      chainId: "cosmoshub-4",
      rpcUrls: ["https://lcd-cosmoshub.keplr.app"],
      blockExplorerUrls: ["https://atomscan.com/"],
      vmType: "CVM"
    },
    kyve: {
      name: "Kyve",
      symbol: "KYVE",
      decimals: 6,
      chainId: "korellia",
      rpcUrls: ["https://api.korellia.kyve.network"],
      blockExplorerUrls: ["https://explorer.kyve.network/"],
      vmType: "CVM"
    },
    evmosCosmos: {
      name: "EVMOS Cosmos",
      symbol: "EVMOS",
      decimals: 18,
      chainId: "evmos_9001-2",
      rpcUrls: ["https://rest.bd.evmos.org:1317"],
      blockExplorerUrls: ["https://evmos.bigdipper.live"],
      vmType: "CVM"
    },
    evmosCosmosTestnet: {
      name: "Evmos Cosmos Testnet",
      symbol: "EVMOS",
      decimals: 18,
      chainId: "evmos_9000-4",
      rpcUrls: ["https://rest.bd.evmos.dev:1317"],
      blockExplorerUrls: ["https://testnet.bigdipper.live"],
      vmType: "CVM"
    },
    cheqdMainnet: {
      name: "Cheqd Mainnet",
      symbol: "CHEQ",
      decimals: 9,
      chainId: "cheqd-mainnet-1",
      rpcUrls: ["https://api.cheqd.net"],
      blockExplorerUrls: ["https://explorer.cheqd.io"],
      vmType: "CVM"
    },
    cheqdTestnet: {
      name: "Cheqd Testnet",
      symbol: "CHEQ",
      decimals: 9,
      chainId: "cheqd-testnet-6",
      rpcUrls: ["https://api.cheqd.network"],
      blockExplorerUrls: ["https://testnet-explorer.cheqd.io"],
      vmType: "CVM"
    },
    juno: {
      name: "Juno",
      symbol: "JUNO",
      decimals: 6,
      chainId: "juno-1",
      rpcUrls: ["https://rest.cosmos.directory/juno"],
      blockExplorerUrls: ["https://www.mintscan.io/juno"],
      vmType: "CVM"
    }
  };
  var ALL_LIT_CHAINS = {
    ...LIT_CHAINS,
    ...LIT_SVM_CHAINS,
    ...LIT_COSMOS_CHAINS
  };

  // packages/misc/src/lib/misc.ts
  function addTimeUnitToGivenDate(duration, unit, date = /* @__PURE__ */ new Date()) {
    switch (unit) {
      case "seconds":
        date.setSeconds(date.getSeconds() + duration);
        break;
      case "minutes":
        date.setMinutes(date.getMinutes() + duration);
        break;
      case "hours":
        date.setHours(date.getHours() + duration);
        break;
      case "days":
        date.setDate(date.getDate() + duration);
        break;
      default:
        throw new Error(`Invalid unit of time: ${unit}`);
    }
    return date;
  }

  // packages/lit-storage/src/lib/lit-storage.ts
  var LitStorage = class {
    constructor({ storageProvider } = {}) {
      this.keys = {
        autoAuth: "lit-auto-auth"
      };
      if (storageProvider && Object.keys(storageProvider).length > 0) {
        this.storage = storageProvider;
      } else if (typeof window !== "undefined") {
        this.storage = window.localStorage;
      } else {
        this.storage = new LitNodejsStorage();
      }
    }
    get length() {
      return this.storage.length;
    }
    clear() {
      return this.storage.clear();
    }
    getItem(key) {
      return this.storage.getItem(key);
    }
    getAllItems() {
      const items = {};
      for (let i = 0; i < this.storage.length; i++) {
        const key = this.storage.key(i);
        if (key) {
          const item = this.storage.getItem(key);
          if (item) {
            items[key] = item;
          }
        }
      }
      return items;
    }
    key(index) {
      return this.storage.key(index);
    }
    removeItem(key) {
      return this.storage.removeItem(key);
    }
    setItem(key, value) {
      return this.storage.setItem(key, value);
    }
    isExpired(key) {
      const itemStr = this.storage.getItem(key);
      if (!itemStr)
        return true;
      const item = JSON.parse(itemStr);
      if (item && item.expirationDate) {
        const expirationDate = new Date(item.expirationDate);
        return /* @__PURE__ */ new Date() > expirationDate;
      }
      return false;
    }
    // -- extra functions
    setExpirableItem(key, value, duration, unit) {
      const expirationDate = addTimeUnitToGivenDate(duration, unit, /* @__PURE__ */ new Date());
      const item = {
        value,
        expirationDate: expirationDate.toJSON()
      };
      return this.storage.setItem(key, JSON.stringify(item));
    }
    getExpirableItem(key) {
      const itemStr = this.storage.getItem(key);
      if (!itemStr)
        return null;
      const item = JSON.parse(itemStr);
      if (item && item.expirationDate) {
        const expirationDate = new Date(item.expirationDate);
        if (/* @__PURE__ */ new Date() > expirationDate) {
          this.storage.removeItem(key);
          return null;
        }
        return item.value;
      }
      return null;
    }
    isItemExpired(key) {
      const itemStr = this.storage.getItem(key);
      if (!itemStr)
        return true;
      const item = JSON.parse(itemStr);
      if (item && item.expirationDate) {
        const expirationDate = new Date(item.expirationDate);
        return /* @__PURE__ */ new Date() > expirationDate;
      }
      return false;
    }
    // -- convert expirable to ISO string
    convertToISOString(expirationLength, expirationUnit) {
      let multiplier;
      const unit = expirationUnit.endsWith("s") ? expirationUnit.slice(0, -1) : expirationUnit;
      switch (unit) {
        case "second":
          multiplier = 1e3;
          break;
        case "minute":
          multiplier = 1e3 * 60;
          break;
        case "hour":
          multiplier = 1e3 * 60 * 60;
          break;
        case "day":
          multiplier = 1e3 * 60 * 60 * 24;
          break;
        case "week":
          multiplier = 1e3 * 60 * 60 * 24 * 7;
          break;
        case "month":
          multiplier = 1e3 * 60 * 60 * 24 * 30;
          break;
        case "year":
          multiplier = 1e3 * 60 * 60 * 24 * 365;
          break;
        default:
          throw new Error(`Invalid unit of time: ${expirationUnit}`);
      }
      return new Date(Date.now() + multiplier * expirationLength).toISOString();
    }
  };
  return __toCommonJS(src_exports);
})();
//# sourceMappingURL=lit-storage.js.map
